## Create Contract

### cURL

```bash
curl --request POST \
  --url https://api.m3ter.com/organizations/{orgId}/contracts \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "accountId": "<string>",
  "name": "<string>",
  "startDate": "2023-12-25",
  "endDate": "2023-12-25",
  "version": 123,
  "customFields": {},
  "code": "<string>",
  "description": "<string>",
  "purchaseOrderNumber": "<string>",
  "applyContractPeriodLimits": true,
  "usageFilters": [
    {
      "dimensionCode": "<string>",
      "value": "<string>"
    }
  ],
  "billGroupingKeyId": "<string>"
}
'
```

### Python

```python
import requests

url = "https://api.m3ter.com/organizations/{orgId}/contracts"

payload = {
    "accountId": "<string>",
    "name": "<string>",
    "startDate": "2023-12-25",
    "endDate": "2023-12-25",
    "version": 123,
    "customFields": {},
    "code": "<string>",
    "description": "<string>",
    "purchaseOrderNumber": "<string>",
    "applyContractPeriodLimits": True,
    "usageFilters": [
        {  
            "dimensionCode": "<string>",
            "value": "<string>"
        }
    ],
    "billGroupingKeyId": "<string>"
}

headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```javascript
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    accountId: '<string>',
    name: '<string>',
    startDate: '2023-12-25',
    endDate: '2023-12-25',
    version: 123,
    customFields: {},
    code: '<string>',
    description: '<string>',
    purchaseOrderNumber: '<string>',
    applyContractPeriodLimits: true,
    usageFilters: [{dimensionCode: '<string>', value: '<string>'}],
    billGroupingKeyId: '<string>'
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/contracts', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/contracts",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'accountId' => '<string>',
    'name' => '<string>',
    'startDate' => '2023-12-25',
    'endDate' => '2023-12-25',
    'version' => 123,
    'customFields' => [],
    'code' => '<string>',
    'description' => '<string>',
    'purchaseOrderNumber' => '<string>',
    'applyContractPeriodLimits' => true,
    'usageFilters' => [[
            'dimensionCode' => '<string>',
            'value' => '<string>'
    ]],
    'billGroupingKeyId' => '<string>'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/contracts"

payload := strings.NewReader(`{
  "accountId": "<string>",
  "name": "<string>",
  "startDate": "2023-12-25",
  "endDate": "2023-12-25",
  "version": 123,
  "customFields": {},
  "code": "<string>",
  "description": "<string>",
  "purchaseOrderNumber": "<string>",
  "applyContractPeriodLimits": true,
  "usageFilters": [
    {
      "dimensionCode": "<string>",
      "value": "<string>"
    }
  ],
  "billGroupingKeyId": "<string>"
}`)

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Response Structure

#### Success Response
```json
{
  "id": "<string>",
  "version": 123,
  "customFields": {},
  "accountId": "<string>",
  "name": "<string>",
  "code": "<string>",
  "description": "<string>",
  "purchaseOrderNumber": "<string>",
  "applyContractPeriodLimits": true,
  "usageFilters": [
    {
      "dimensionCode": "<string>",
      "value": "<string>"
    }
  ],
  "billGroupingKeyId": "<string>",
  "startDate": "2023-12-25",
  "endDate": "2023-12-25",
  "dtCreated": "2023-11-07T05:31:56Z",
  "dtLastModified": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "lastModifiedBy": "<string>"
}
```

#### Error Response
```json
{
  "message": "<string>"
}
```
